package com.jpattern.orm.persistor;

import java.sql.PreparedStatement;
import java.sql.ResultSet;

/**
 * @author Francesco Cina
 *
 * 22/mag/2011
 * 
 * The bytecode of classes that implement this interface is generated at runtime using cojen
 * 
 */
public interface IOrmPersistor<T>  {

	T mapRow(String rowNamePrefix, ResultSet rs, int rowNum);

	T clone(T entity);

	Object[] allValues(T entity);
	void setAllValues(T entity, PreparedStatement ps);

	Object[] allNotGeneratedValues(T entity);
	void setAllNotGeneratedValues(T entity, PreparedStatement ps);

	Object[] primaryKeyValues(T entity);
	void setPrimaryKeyValues(T entity, PreparedStatement ps);

	Object[] notPrimaryKeyValues(T entity);
	void setNotPrimaryKeyValues(T entity, PreparedStatement ps);

	void setNotPrimaryKeyAndThenPrimaryKeyValues(T entity, PreparedStatement ps);

	Object[] primaryKeyAndVersionValues(T entity);
	void setPrimaryKeyAndVersionValues(T entity, PreparedStatement ps);

	void increaseVersion(T entity, boolean firstVersionNumber);

	/**
	 * Return whether in the save query there are automatically
	 * generated key (for example using a call to a Sequence in the
	 * insert query)
	 * @return
	 */
	boolean useKeyGenerators(T entity);

	void updateGeneratedValues(ResultSet rs, T entity);

	boolean hasGenerators();

	boolean hasConditionalGenerator();

}
