package com.jpattern.orm.persistor.reflection.field;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

import com.jpattern.orm.persistor.anew.type.TypeWrapper;

/**
 * 
 * Get the value of a field directly accessing his value
 * 
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public class FieldWrappedSetFieldManipulator extends SetFieldManipulator {

	private final Field field;
	private final TypeWrapper<Object, Object> wrapper;

	public FieldWrappedSetFieldManipulator(Field field, Method resultSetGetterMethodString, Method resultSetGetterMethodInt, TypeWrapper<Object, Object> wrapper) {
		super(resultSetGetterMethodString, resultSetGetterMethodInt);
		this.field = field;
		this.wrapper = wrapper;
		field.setAccessible(true);
	}

	@Override
	public void setValue(Object bean, Object value) throws IllegalArgumentException, IllegalAccessException {
		field.set(bean, wrapper.wrap(value));
	}

}
