package com.jpattern.orm.persistor.reflection.field;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 * 
 * Set the value of a using the related setter method
 * 
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public class GetterGetFieldManipulator extends GetFieldManipulator {

	private final Method getterMethod;

	public GetterGetFieldManipulator(Method getterMethod) {
		this.getterMethod = getterMethod;
	}

	@Override
	public Object getValue(Object bean) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		return getterMethod.invoke(bean);
	}

}
