package com.jpattern.orm.persistor.reflection.field;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.sql.ResultSet;

/**
 * set a value to a field
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public abstract class SetFieldManipulator<P> {

	private final Method resultSetGetterMethodString;
	private final Method resultSetGetterMethodInt;

	public SetFieldManipulator(final Method resultSetGetterMethodString, final Method resultSetGetterMethodInt) {
		this.resultSetGetterMethodString = resultSetGetterMethodString;
		this.resultSetGetterMethodInt = resultSetGetterMethodInt;
	}

	public abstract void setValue(Object bean, P value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;

	// TODO to remove
	@Deprecated
	public final void setValueFromResultSet(final Object bean, final ResultSet rs, final String rsColumnName) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		setValue(bean, (P) this.resultSetGetterMethodString.invoke(rs, rsColumnName)) ;
	}

	// TODO to remove
	@Deprecated
	public final void setValueFromResultSet(final Object bean, final ResultSet rs, final int rsColumnIndex) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		setValue(bean, (P) this.resultSetGetterMethodInt.invoke(rs, rsColumnIndex)) ;
	}
}
