package com.jpattern.orm.persistor.reflection.field;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;


/**
 * 
 * Get the value of a field using the related getter method
 * 
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public class SetterSetFieldManipulator extends SetFieldManipulator {

	private final Method setterMethod;

	public SetterSetFieldManipulator(Method setterMethod, Method resultSetGetterMethodString, Method resultSetGetterMethodInt) {
		super(resultSetGetterMethodString, resultSetGetterMethodInt);
		this.setterMethod = setterMethod;
	}

	@Override
	public void setValue(Object bean, Object value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		setterMethod.invoke(bean, value);
	}

}
