package com.jpattern.orm.persistor.reflection.field;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import com.jpattern.orm.persistor.anew.type.TypeWrapper;

/**
 * 
 * Get the value of a field using the related getter method
 * 
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public class SetterWrappedSetFieldManipulator extends SetFieldManipulator {

	private final Method setterMethod;
	private final TypeWrapper<Object, Object> wrapper;

	public SetterWrappedSetFieldManipulator(Method setterMethod, Method resultSetGetterMethodString, Method resultSetGetterMethodInt, TypeWrapper<Object, Object> wrapper) {
		super(resultSetGetterMethodString, resultSetGetterMethodInt);
		this.setterMethod = setterMethod;
		this.wrapper = wrapper;
	}

	@Override
	public void setValue(Object bean, Object value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		setterMethod.invoke(bean, wrapper.wrap(value));
	}

}
