package com.jpattern.orm.persistor.reflection.version;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import com.jpattern.orm.persistor.reflection.FieldManipulator;

/**
 * 
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public class ReflectionVersionManipulator implements VersionManipulator {

	private final Method versionMethod;
	private final FieldManipulator manipulator;

	public ReflectionVersionManipulator(Class<?> columnType, FieldManipulator manipulator) throws SecurityException, NoSuchMethodException {
		versionMethod = VersionIncreaseHelper.class.getMethod("increase", Boolean.TYPE, columnType);
		this.manipulator = manipulator;
	}

	@Override
	public void increaseVersion(Object bean, boolean firstVersionNumber) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		final Object currentVersion = manipulator.getValue(bean);
		final Object newVersion = versionMethod.invoke(null, firstVersionNumber, currentVersion);
		manipulator.setValue(bean, newVersion);
	}

}
