package com.jpattern.orm.persistor.statement;

import java.sql.Clob;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class ClobPreparedStatementWriter extends
PreparedStatementWriter<Clob> {

	@Override
	public void setValueToPreparedStatement(final Object value, final PreparedStatement ps,
			final int index) throws SQLException {
		if (value!=null) {
			ps.setClob(index, castValue(value));
		} else {
			ps.setObject(index, value);
		}
	}

	@Override
	protected Clob castValue(final Object value) {
		return (Clob) value;
	}

}
