package com.jpattern.orm.persistor.statement;

import java.io.InputStream;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class InputStreamPreparedStatementWriter extends PreparedStatementWriter<InputStream> {

	@Override
	public void setValueToPreparedStatement(final Object value, final PreparedStatement ps, final int index) throws SQLException {
		if (value!=null) {
			ps.setBinaryStream(index, castValue(value));
		} else {
			ps.setObject(index, value);
		}
	}

	@Override
	protected InputStream castValue(final Object value) {
		return (InputStream) value;
	}

}
