package com.jpattern.orm.persistor.statement;

import java.io.Reader;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class ReaderPreparedStatementWriter extends
PreparedStatementWriter<Reader> {

	@Override
	public void setValueToPreparedStatement(final Object value, final PreparedStatement ps,
			final int index) throws SQLException {
		if (value!=null) {
			ps.setCharacterStream(index, castValue(value));
		} else {
			ps.setObject(index, value);
		}
	}

	@Override
	protected Reader castValue(final Object value) {
		return (Reader) value;
	}

}
